var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import {
  getCurrentInstance,
  inject,
  onUnmounted,
  computed
} from "vue";
const useProvider = (key) => {
  const context = inject(key, null);
  if (context) {
    const instance = getCurrentInstance();
    const _a = context, { link, unlink, internalChildren } = _a, rest = __objRest(_a, ["link", "unlink", "internalChildren"]);
    link(instance);
    onUnmounted(() => unlink(instance));
    const idx = computed(() => internalChildren.indexOf(instance));
    return {
      context: rest,
      idx: idx.value
    };
  }
  return {
    context: null,
    idx: -1
  };
};
export {
  useProvider
};
