import { ref, readonly } from "vue";
const useState = (initial) => {
  const state = ref(initial);
  const dispatch = (next) => {
    const draft = typeof next === "function" ? next(state.value) : next;
    state.value = draft;
  };
  return [readonly(state), dispatch];
};
export {
  useState
};
