var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  useClickAway: () => useClickAway
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_use_event_listener = require("../use-event-listener");
const defaultOptions = {
  event: "click"
};
const isBrowser = () => {
  return Boolean(typeof window !== "undefined" && window.document && window.document.createElement);
};
const useClickAway = (listener, target, options = defaultOptions) => {
  if (!isBrowser())
    return;
  const onClick = (evt) => {
    const element = (0, import_vue.unref)(target);
    if (element && !element.contains(evt.target)) {
      listener(evt);
    }
  };
  (0, import_use_event_listener.useEventListener)(options.event, onClick, { target: document });
};
