var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  useClipboard: () => useClipboard
});
module.exports = __toCommonJS(stdin_exports);
const createElement = () => {
  const _el = document.createElement("div");
  _el.style.whiteSpace = "pre";
  return _el;
};
const useClipboard = () => {
  const _el = createElement();
  const copyText = (text) => {
    if (!text)
      return;
    const selection = window.getSelection();
    if (!selection)
      return;
    const range = document.createRange();
    _el.textContent = text;
    document.body.appendChild(_el);
    range.selectNode(_el);
    selection.removeAllRanges();
    selection.addRange(range);
    try {
      document.execCommand("Copy");
    } catch (error) {
      console.error("copy failed!");
    }
    selection.removeAllRanges();
    _el.textContent = "";
    document.body.removeChild(_el);
  };
  return { copyText };
};
