var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  useTitle: () => useTitle
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_use_state = require("../use-state");
const useTitle = (initialTitle = "") => {
  const [title, setTitle] = (0, import_use_state.useState)(initialTitle);
  const titleChange = (title2 = "") => setTitle(title2);
  const setDocumentTitle = () => document.title = title.value;
  const resetDocumentTitle = () => document.title = "";
  (0, import_vue.onMounted)(setDocumentTitle);
  (0, import_vue.watch)(title, setDocumentTitle);
  (0, import_vue.onBeforeUnmount)(resetDocumentTitle);
  (0, import_vue.onDeactivated)(resetDocumentTitle);
  return {
    titleChange,
    title
  };
};
