import { VNode, VNodeNormalizedChildren, ComponentPublicInstance, ComponentInternalInstance, InjectionKey } from 'vue';
export declare const flattenVNodes: (children: VNodeNormalizedChildren) => VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>[];
export declare const sortChildren: (parent: ComponentInternalInstance, publicChildren: ComponentPublicInstance[], internalChildren: ComponentInternalInstance[]) => void;
export declare const createProvider: <T extends ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> = ComponentPublicInstance<{}, any, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>>, ProvideValue = never>(key: InjectionKey<ProvideValue>) => {
    children: T[];
    provider: (value?: ProvideValue | undefined) => void;
};
